



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>keras 的 Deeplabv3+ 实现遇到的问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">keras 的 Deeplabv3+ 实现遇到的问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 21:59:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>代码大佬都已经写好了，具体参考：https://github.com/bonlime/keras-deeplab-v3-plus</p>
<p>git clone 下来以后，按照指南要训练自己的数据集，只要设置好自己的数据大小和类别就可以了</p>
<div>
<pre class="prettyprint linenums">from model import Deeplabv3<br />
deeplab_model = Deeplabv3(input_shape=(384, 384, 3), classes=4)</pre>
</div>
<p>问题1：我的数据集不是一张张小图片，而是一个大的遥感影像tif，如何训练这个数据</p>
<p>解决：用 gdal 读取得到它的 np.array，再通过生成器一小块一小块输入</p>
<p>问题2：但是这样的生成器无法打乱顺序，把多景影像标签和图像 zip 起来后也无法用 random.shuffle 打乱图片顺序</p>
<p>解决：现在只能每次都按顺序读入，应该对训练影响不大</p>
<p>设想：后续想法是设置一个随机数列，根据这个随机数列读取指定大小范围，这样是把步长变为了1，会有好多样本</p>
<p>问题3：验证集和训练集只能按 tif 分，如何能随机取</p>
<p>设想：随机数列解决</p>
<p>问题4：运行一直报错，各种错，先后有</p>
<p>　　module 'tensorflow._api.v1.compat' has no attribute 'v1'</p>
<p>　　unsupported operand type(s) for /: 'Dimension' and 'float'</p>
<p>解决：直接 git clone 下来的是用最新版 tf2.0 写的，需要升级自己的 tf 或者用作者之前版本的实现，在这里<strong>用了之前版本的 keras 实现</strong>，在命令行输入一下代码</p>
<div>
<pre class="prettyprint linenums">git clone https://github.com/bonlime/keras-deeplab-v3-plus/<br />
cd keras-deeplab-v3-plus/<br />
git checkout 714a6b7d1a069a07547c5c08282f1a706db92e20</pre>
</div>
<p>问题5：写的生成器生成的标签最后一维是1，导致运行一直报错，维度不匹配</p>
<p>解决：这个写的是用了 <strong>one-hot 编码</strong>的，需要把标签转换成 one-hot，用 &ldquo; from keras.utils import to_categorical &rdquo;，to_categorical(x, num_classes=n)把 x 里从 0 到 n-1的值根据大小扩展到 n 维，若最大值和类别数目不同会报错</p>
<p>问题6：评价指标 loss 和各种系数不在正常范围内</p>
<p>解决：一开始以为是 one-hot 编码问题，一直尝试用 k.argmax 去得到1维的 tensor，死活弄不出来，报错有：数据类型不对，用 K.cast 强制转换解决，tensor 不能和数值相加，用argmax导致梯度无法回流等。睡了一觉想想不能用 argmax，他就是要在每一个维度上计算出相应指标再求平均，原来在不是 one-hot 编码里用的函数都还是对的，那问题出在老版本里最后没有用激活函数，给他<strong>加个激活函数</strong>以后一切都正常了。</p>
<p>问题7：作者说没有实现 weight_decay，需要的自己加</p>
<p>还未解决：不知道去哪加</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4rd38z.html">flask&plus;sqlite3&plus;echarts2&plus;ajax数据可视化报错：UnicodeDecodeError&colon; &amp;&num;39&semi;utf8&amp;&num;39&semi; codec can&amp;&num;39&semi;t decode byte解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv2dkz9.html">&lbrack;&period;net 面向对象编程基础&rsqb;  &lpar;1&rpar;  开篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9poegkq.html">git 添加ssh的方法 push免登陆</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvxjm18.html">hdu 1233 还是畅通工程 解题报告</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mg0k28.html">QUnit使用笔记-5简化编写</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93553rq.html">robotium 新建 android 测试项目：</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ym0w0q.html">Notepad&plus;&plus;配置Python运行环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj7rw79.html">ORA-12838&colon; cannot read&sol;modify an object after modifying it in parallel</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmrxx09.html">Handler一定要在主线程实例化吗&quest;new Handler&lpar;&rpar;和new Handler&lpar;Looper&period;getMainLooper&lpar;&rpar;&rpar;的区别&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1ey769.html">nodejs调试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydzd7xq.html">python3-day3&lpar;函数-参数&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1k40yq.html">Linux Oracle服务启动&amp;amp&semi;停止脚本与开机自启动&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z735n9.html">201521123013 《Java程序设计》第5周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me7pyrq.html">Struts源码之OgnlValueStack</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wx7j0q.html">Qt  学习-----helloword</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4yw5j9.html">吴裕雄 python matplotlib 绘图示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyodyx9.html">Python中的迭代器、生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/q250r7xq.html">css上传图片中等待不可点击效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/960z42j9.html">在Linux服务器上配置Transmission来离线下载BT种子</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w5vv0q.html">指令发布中如何实现new新消息的提醒？</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rge0gd8.html">Kafka并不难学</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zodjx3q.html">【Java基础】【08面向对象&lowbar;继承&amp;amp&semi;方法&amp;amp&semi;final】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkp5xz8.html">alibaba &sol; zeus 安装  图解</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzw2ye8.html">-1-7 java 网络编程基本知识点 计算机网络 TCP&sol;IP协议栈 通信必备 tcp udp</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpnky7q.html">Perl一行式：文本编解码、替换</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj7lj28.html">python学习笔记&lpar;五&rpar;、抽象</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z6jo19.html">Java开发笔记（八）五种算术运算符</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj7ld28.html">Java开发笔记（四十六）类的构造方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojzo65q.html">bootstrap思考一</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zr2pn9.html">JavaScript 包装对象</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
